#pragma semicolon 1
#include <sourcemod>

public Plugin:myinfo = 
{
	name	= "Regen Hp",
	author	= "wS / Schmidt",
	version	= "1.1",
	url		= "http://world-source.ru/"
};

new Handle:g_Timer[MAXPLAYERS+1];
new Handle:regen_hp_timer;
new Handle:regen_hp;

public OnPluginStart()
{
	regen_hp_timer = CreateConVar("regen_hp_timer", "1", "Добавлять HP каждые 'x' секунд", _, true, 1.0, true, 60.0);
	regen_hp = CreateConVar("regen_hp", "1", "Сколько добавлять HP", _, true, 1.0, true, 99.0);

	HookEvent("player_spawn",	player_spawn);
	HookEvent("player_hurt",	player_hurt);
}


///


public player_spawn(Handle:event, const String:name[], bool:silent)
{
	wS_KillTimer(GetClientOfUserId(GetEventInt(event, "userid")));
}

public OnClientDisconnect(client)
{
	wS_KillTimer(client);
}

wS_KillTimer(client)
{
	if (g_Timer[client] != INVALID_HANDLE)
	{
		KillTimer(g_Timer[client]);
		g_Timer[client] = INVALID_HANDLE;
	}
}


///


public player_hurt(Handle:event, const String:name[], bool:silent)
{
	if (GetEventInt(event, "health") < 1)
		return;

	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if (g_Timer[client] != INVALID_HANDLE)
		return;

	g_Timer[client] = CreateTimer(GetConVarFloat(regen_hp_timer), wS, client, TIMER_REPEAT);
}

public Action:wS(Handle:timer, any:client)
{
	if (IsPlayerAlive(client))
	{
		new hp = GetEntProp(client, Prop_Send, "m_iHealth");
		if (hp < 100)
		{
			hp += GetConVarInt(regen_hp);
			if (hp > 100) hp = 100;
			SetEntProp(client, Prop_Send, "m_iHealth", hp);
			if (hp < 100) return Plugin_Continue;
		}
	}
	g_Timer[client] = INVALID_HANDLE;
	return Plugin_Stop;
}